-- SOUND EFFECTS:
freeslot("sfx_float", "sfx_cancel", "sfx_levi")	-- float

-- BOT BUBBLES:
freeslot("SPR_SFLI", "S_SILV_WARNINGINDICATOR", "S_SILV_TIREDINDICATOR")
states[S_SILV_WARNINGINDICATOR] = {SPR_SFLI, A|FF_ANIMATE|FF_FULLBRIGHT, -1, nil, 3, 2, S_SILV_WARNINGINDICATOR}
states[S_SILV_TIREDINDICATOR] = {SPR_SFLI, E|FF_ANIMATE|FF_FULLBRIGHT, -1, nil, 1, 6, S_SILV_TIREDINDICATOR}

-- TELEKINESIS LOCKON:
freeslot("SPR_SLCK", "S_LOCKON_SILV")
states[S_LOCKON_SILV] = {SPR_SLCK, FF_FULLBRIGHT, 2, nil, 0, 0, S_NULL}

-- TELEKINESIS AURA:
freeslot("SPR_FRAG")
for i = 1, 5
	freeslot("S_FRAG"..i)
end
local trans = {TR_TRANS50, TR_TRANS60, TR_TRANS70, TR_TRANS80, TR_TRANS80}
for i = 0,4
	states[S_FRAG1+i]	= {SPR_FRAG, i|FF_FULLBRIGHT|trans[i+1], 3, nil, 0, 0, i<3 and S_FRAG2+i or S_NULL}
end

freeslot("SPR_HOWL", "S_HOWL1", "S_HOWL2", "S_HOWL3")
local tlookup = {TR_TRANS50, TR_TRANS70, TR_TRANS80}
for i = 0, 2 do
	states[S_HOWL1+i] = {SPR_HOWL, i|tlookup[i+1]|FF_PAPERSPRITE, 2, nil, 0, 0, i < 2 and S_HOWL2+i or S_NULL}
end

-- IDLE:
freeslot("SPR_RGRB")

-- shield abilities:
freeslot("SPR_KLIT")

-- TELEKINESIS STATES
freeslot("MT_PSYHITBOX", "S_SILVTHROW")
mobjinfo[MT_PSYHITBOX] = {
	-1,
	S_INVISIBLE,
	1,
	S_NULL,
	sfx_None,
	0,
	sfx_None,
	S_NULL,
	0,
	sfx_None,
	S_NULL,
	S_NULL,
	S_NULL,
	S_NULL,
	sfx_None,
	6,
	64 * FRACUNIT,
	64 * FRACUNIT,
	0,
	100,
	0,
	sfx_None,
	MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP,
	S_NULL
}

-- VERY SPECIFIC EGG ROBO SPAWNER HELPER
freeslot("MT_EGGROBO_SPAWNHELPER", "S_EGGROBO_SPAWNHELPER")
mobjinfo[MT_EGGROBO_SPAWNHELPER] = {
	doomednum = -1,
	spawnhealth = 1000,
	spawnstate = S_EGGROBO_SPAWNHELPER,
	height = 1,
	radius = 1,	-- doesn't matter
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_RUNSPAWNFUNC,
}

-- make an eggrobo "descend"
function A_EggRoboSpawnHelper(mo)
	if not mo or not mo.valid return end
	local t = mo.target	-- < this is our eggrobo
	if not t or not t.valid return end	-- no target

	if mo.extravalue1
		t.flags2 = $|MF2_DONTDRAW
		mo.extravalue1 = $-1
		if not mo.extravalue1
			t.flags2 = $ & ~MF2_DONTDRAW
		end
	end

	if mo.extravalue2
		mo.extravalue2 = $-1
		-- update our target:
		t.angle = mo.angle
		t.z = mo.z
		t.threshold = mo.z
		return
	end

	mo.momz = (mo.threshold-mo.z)/4
	-- update our target:
	t.angle = mo.angle
	t.z = mo.z
	t.threshold = mo.z

	if not mo.momz and not mo.extravalue1
		t.flags = $ & ~(MF_NOCLIP|MF_NOCLIPHEIGHT)
		P_RemoveMobj(mo)
		return
	end
end

states[S_EGGROBO_SPAWNHELPER] = {SPR_NULL, A, 1, A_EggRoboSpawnHelper, 0, 0, S_EGGROBO_SPAWNHELPER}

function A_SilvCopyState(actor)	-- copy a mobj's spawnstate so that Silver can throw objects that overwrite movement (like buzzes)
	local tpe = actor.silv_desperatemeasure or actor.type
	actor.sprite = states[mobjinfo[tpe].spawnstate].sprite
	actor.frame = states[mobjinfo[tpe].spawnstate].frame
end
states[S_SILVTHROW] = {SPR_NULL, A, 1, A_SilvCopyState , 0, 0, S_SILVTHROW}

-- SPIN TRAIL ITEM:

freeslot("MT_SILVERTRAIL", "SPR_STHK", "S_SILVERTRAIL1", "S_SILVERTRAIL2")

function A_TrailColor(actor)
	local t = actor.target
	if not t or not t.valid or not t.player or not t.player.valid
		actor.color = SKINCOLOR_AQUA
	return end
	actor.color = silv_auracolor(t.player)
end

mobjinfo[MT_SILVERTRAIL] = {
	doomednum = -1,
	spawnstate = S_SILVERTRAIL1,
	height = 32*FRACUNIT,
	radius = 16*FRACUNIT,
	flags = MF_NOCLIP|MF_NOBLOCKMAP|MF_NOGRAVITY|MF_RUNSPAWNFUNC
}
states[S_SILVERTRAIL1] = {SPR_NULL, 0, 1, nil, 0, 0, S_SILVERTRAIL2}
states[S_SILVERTRAIL2] = {SPR_STHK, FF_TRANS70|FF_FULLBRIGHT, 16, A_TrailColor, 0, 0, S_NULL}

-- IDLE ITEMS
freeslot("MT_SILV_IDLEHOLD", "S_SILV_IDLEHOLD")
mobjinfo[MT_SILV_IDLEHOLD] = {
	doomednum = -1,
	spawnhealth = 1000,
	spawnstate = S_SILV_IDLEHOLD,
	radius = 16<<FRACBITS,
	height = 32<<FRACBITS,	-- doesn't matter
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP|MF_NOGRAVITY
}
states[S_SILV_IDLEHOLD] = {SPR_NULL, 0, -1, nil, 0, 0, S_SILV_IDLEHOLD}	-- dummy state

-- FUNCTIONS

-- silv_blockingWall:
--	returns true if mobj is hitting a wall fast enough
local function PIT_blockLine(mo, l)
	if mo.flags & (MF_BOSS) and l.flags & ML_BLOCKMONSTERS
		return true
	end
end

rawset(_G, "silv_blockingWall", function(mobj, autothrust)

	mobj.tester = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_GARGOYLE) -- Has the best chance of not getting cleared on spawn
	local tester = mobj.tester
	tester.flags = MF_NOGRAVITY|MF_NOCLIPTHING|(mobj.flags & MF_BOSS) -- Make sure it won't move or block things
	tester.state = S_INVISIBLE -- make sure it fucks off afterwards
	tester.tics = 1

    tester.radius = mobj.radius
    tester.height = mobj.height
	-- special case...
	if mobj.type == MT_PSYCHOCUT
	and mobj.target and mobj.target.valid
		tester.radius = mobj.target.radius
		tester.height = mobj.target.height
	end
	if autothrust	-- this is for the psycho boost.
		P_InstaThrust(tester, mobj.angle, 8*mobj.scale)	-- little test
	else
		local angle = R_PointToAngle2(mobj.x, mobj.y, mobj.x+mobj.momx, mobj.y+mobj.momy)
		tester.angle = angle

		local maxdist = FixedHypot(mobj.momx, mobj.momy)
		P_InstaThrust(tester, angle, maxdist) -- Misuse P_InstaThrust to easily get the distance to move
	end

	local move = P_TryMove(tester, tester.momx+mobj.x, tester.momy+mobj.y, true)
	if not move return true end	-- couldn't move -> collide
	-- if nothing happened;

	tester.radius = $*2
	if not searchBlockmap("lines", PIT_blockLine, tester)
		return true
	end
	tester.radius = $/2
end)

-- silver aura color:
rawset(_G, "silv_auracolor", function(p)
	if G_GametypeHasTeams()
		return p.skincolor
	end

	if p.silv_auracolor == -1
		return ColorOpposite(p.skincolor)
	elseif p.silv_auracolor == nil or p.silv_auracolor <= 0 or p.silv_auracolor >= MAXSKINCOLORS
		return SKINCOLOR_AQUA
	else
		return p.silv_auracolor
	end
end)

local color_names = {
	"white",
	"bone",
	"cloudy",
	"grey",
	"silver",
	"carbon",
	"jet",
	"black",

	"aether",
	"slate",
	"pink",
	"yogurt",
	"brown",
	"tan",
	"beige",
	"moss",
	"azure",
	"lavender",

	"ruby",
	"salmon",
	"red",
	"crimson",
	"flame",
	"peachy",
	"quail",
	"sunset",
	"apricot",
	"orange",
	"rust",
	"gold",
	"sandy",
	"yellow",
	"olive",
	"lime",
	"peridot",
	"green",
	"forest",
	"emerald",
	"mint",
	"seafoam",
	"aqua",
	"teal",
	"wave",
	"cyan",
	"sky",
	"cerulean",
	"icy",
	"sapphire",
	"cornflower",
	"blue",
	"cobalt",
	"vapor",
	"dusk",
	"pastel",
	"purple",
	"bubblegum",
	"magenta",
	"neon",
	"violet",
	"lilac",
	"plum",
	"rosy",

	[-1] = "opposite",
}

COM_AddCommand("auracolor", function(p, arg)
	if arg == nil
		CONS_Printf(p, "auracolor: Change your aura color when playing as Silver. Set to \'-1\' or \'Opposite\' for opposite color.")
		return
	end

	local args = arg:lower()
	local argn = tonumber(arg)

	if args == "opposite"
		p.silv_auracolor = -1	-- easier for me
		return
	end

	if argn
		if (argn > 0 and argn < MAXSKINCOLORS) or argn == -1
			p.silv_auracolor = argn
		else
			CONS_Printf(p, "Color not in range")
		end
		return
	end

	for i = 1, #color_names
		if color_names[i] == args
			p.silv_auracolor = i
			return
		end
	end
end
)

-- CUT
freeslot("MT_PSYCHOCUT", "SPR_PSCT", "sfx_pscut")
freeslot("S_PSYCUT", "S_PSYCUT2")
mobjinfo[MT_PSYCHOCUT] = {
	-1,
	S_PSYCUT,
	1,
	S_NULL,
	sfx_None,
	0,
	sfx_None,
	S_NULL,
	0,
	sfx_None,
	S_NULL,
	S_NULL,
	S_NULL,
	S_NULL,
	sfx_None,
	6,
	32 * FRACUNIT,
	64 * FRACUNIT,
	0,
	100,
	0,
	sfx_None,
	MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIPHEIGHT|MF_NOCLIP,
	S_NULL
}
mobjinfo[MT_PSYCHOCUT].speed = FRACUNIT*45
mobjinfo[MT_PSYCHOCUT].painchance = 192*FRACUNIT

addHook("MobjThinker", function(mo)
	if mo and mo.valid
		local c = mo.colours
		if (c and c[2])
			mo.color = leveltime%4 >= 2 and c[2] or c[1]
		end
	end
end, MT_PSYCHOCUT)

function A_PsycutWallcheck(mo)
	if mo and mo.valid
		local c = P_SpawnMobj(mo.x, mo.y, mo.z, MT_PSYCHOCUT)
		mo.angle = R_PointToAngle2(mo.x, mo.y, mo.x+mo.momx, mo.y+mo.momy)
		c.state = S_INVISIBLE
		c.weapon = mo.weapon
		c.tics = 1
		c.height = mo.height
		c.radius = mo.radius
		c.flags = MF_MISSILE|MF_NOGRAVITY|MF_NOCLIPHEIGHT
		c.target = mo.target
		if leveltime%2
			local g = P_SpawnGhostMobj(mo)
			g.colorized = true
			g.tics = 4
		end

		if mo.weapon == WEP_GRENADE
			mo.momx = FixedMul(64500, $)
			mo.momy = FixedMul(64500, $)
			mo.momz = FixedMul(64500, $)

			if FixedHypot(mo.momx, mo.momy) < FRACUNIT*3
			and mo.momz < FRACUNIT*2
				mo.flags = MF_MISSILE|MF_NOGRAVITY
				A_RingExplode(mo)
				local a = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
				a.state = S_INVISIBLE
				a.tics = TICRATE
				S_StartSound(a, sfx_pop)
				P_RemoveMobj(mo)
				return
			end
		end

		if silv_blockingWall(mo) and not (mo.flags & MF_BOUNCE)
			if mo and mo.explode
				mo.flags = MF_MISSILE|MF_NOGRAVITY
				A_RingExplode(mo)
				local a = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
				a.state = S_INVISIBLE
				a.tics = TICRATE
				S_StartSound(a, sfx_pop)
			end
			P_RemoveMobj(mo)
		end
	end
end

states[S_PSYCUT] = {SPR_PSCT, A|FF_FULLBRIGHT, 1,A_PsycutWallcheck , 0, 0, S_PSYCUT}
states[S_PSYCUT2] = {SPR_PSCT, B|FF_FULLBRIGHT, 1,A_PsycutWallcheck , 0, 0, S_PSYCUT2}

rawset(_G, "friendlyPlayer", function(p1, p2)						-- check 2 players. Returns true if the player is friendly, false else.

	if p1 and p2 and p1.valid and p2.valid

	-- is our player a friend to the other?

		if gametype == GT_COOP		-- Are we on coop?
		or G_PlatformGametype()		-- Race will count because else it's REALLY unfair.
		--and not cv_psynarchy.value

		or (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		and p1.ctfteam == p2.ctfteam						-- Are we on a team gametype with both players on the same team?
		--and not cv_psynarchy.value

		or G_TagGametype()
		and ((p1.pflags & PF_TAGIT and p2.pflags & PF_TAGIT) or (not (p1.pflags & PF_TAGIT) and (not (p2.pflags & PF_TAGIT))))
		--and not cv_psynarchy.value
			--print("friends")
			return true								-- Then both players are friends! =D
		else
			--print("not friends.")
			return false							-- Then they're enemies! >:)
		end
	end
end)