-- silver carry stuff

local function silv_carrycollide(mo, mo2)
	-- mo is our non carried player
	-- mo2 is our floating player

	if not (mo and mo2 and mo.valid and mo2.valid) return end
	if mo2.type ~= MT_PLAYER return end	-- br

	if (mo.eflags & MFE_VERTICALFLIP) ~= (mo2.eflags & MFE_VERTICALFLIP) return end	-- match flipped state
	if not mo.player or not mo2.player or not mo.player.valid or not mo2.player.valid return end
	if mo.player.powers[pw_carry] return end	-- already being carried
	if mo2.player.charability ~= 69	return end	-- good luck
	if mo2.silv_floatstate ~= 1	return end	-- mo2 isn't floating
	if mo.player.cmd.buttons & BT_USE return end

	-- p much the same as P_DoTailsPickup from here on out
	if not (mo2.player.pflags & PF_CANCARRY) return end	-- now that's just sad
	if (mo.player.pflags & PF_FINISHED) return end	-- that's also sad
	if mo.eflags & MFE_VERTICALFLIP
		if (mo2.ceilingz - (mo2.z + mo2.height) < mo.height-FixedMul(2*FRACUNIT, mo.scale)) return end	-- no room (flip)
	elseif 	(mo2.z - mo2.floorz < mo.height-FixedMul(2*FRACUNIT, mo.scale))
		return
	end	-- still no space

	-- already carrying someone?
	for p in players.iterate do
		if p.mo and p.mo.valid and p.powers[pw_carry] == CR_PLAYER and p.mo.tracer == mo2
			return	-- already carrying
		end
	end

	local zdist

	if (mo.eflags & MFE_VERTICALFLIP)
		-- flipped:
		zdist = (mo.z + mo.height) - (mo2.z + mo2.height)
	else
		-- not flipped:
		zdist = mo2.z - mo.z
	end

	if zdist <= mo.height + mo.scale
	and zdist > mo.height*2/3
	and P_MobjFlip(mo2)*mo.momz <= 0

		-- start carrying!
		P_ResetPlayer(mo.player)
		mo.tracer = mo2
		mo.player.powers[pw_carry] = CR_PLAYER

		S_StartSound(mo, sfx_s3k4a)
		P_TeleportMove(mo, mo2.x, mo2.y, mo.z)
	end
end

addHook("MobjCollide", silv_carrycollide, MT_PLAYER)
addHook("MobjMoveCollide", silv_carrycollide, MT_PLAYER)
